#property  copyright "Copyright  2011, sangmane.And pimped by Ramy3"
#property  link      "sangmane@forexfactory.com" 
#import "EasyOrder.dll"
int EasyOrder_Submit(int hwnd, double &alot[]);
#include <stdlib.mqh>
#include <stderror.mqh>
//---------------settings-----------------
int         Color1=Lime;
int         Width1=1;
int         Style1 =3;
int MagicNumber = 8051;
int Slippage = 9;
string TradeComment = "Easy Order";
double LotUnit;
//-----------------------------------------
int start()
{	
	string obj = "EASYORDER_NEW_";
	string aorder[6] = {"Buy", "Sell", "Buy Limit", "Sell Limit", "Buy Stop", "Sell Stop"};
	string desc[3] = {"SL", "Price", "TP"};
	double alot[1]={0};
	double price, sl, tp;

	double pip = Point;
	if(Digits==3 || Digits==5) pip = 10*Point;
	LotUnit = MarketInfo(Symbol(),MODE_LOTSIZE);

	int i;
	
	int hwnd = WindowHandle(Symbol(),Period());
	int trade = EasyOrder_Submit(hwnd, alot);
	bool RiskBased = (trade & 0x100) > 0;
	trade = trade & 0xff;
	while(True) {	
		Print("trade: ",trade);
		if(trade<0) {
			Alert("Submit return error!");
			break;
		}
		trade -= 1;
		if(trade<0) {
			Alert("Invalid order!");
			break;
		}
		
		double lot = alot[0];
		sl = NormalizeDouble(ObjectGet(obj+"SL",OBJPROP_PRICE1),Digits);
		tp = NormalizeDouble(ObjectGet(obj+"TP",OBJPROP_PRICE1),Digits);
		RefreshRates();
		switch(trade) {
			case OP_BUY:			
				price = Ask; break;
			case OP_SELL:
				price = Bid; break;
			default:
				price = NormalizeDouble(ObjectGet(obj+"Price",OBJPROP_PRICE1),Digits); break;
		}
		if(price==0) {
			Alert("Invalid open price for pending order!");
			break;
		}
		if(RiskBased) {
			if(sl==0) {
				Alert("Invalid Stop Loss for Risk-based lot!");
				break;
			}
			Print("Calling RiskToLot..");
			lot = RiskToLot(lot, price, sl);
		}
		if((lot<MarketInfo(Symbol(),MODE_MINLOT)) || (lot>MarketInfo(Symbol(),MODE_MAXLOT))) {
			Alert("Invalid lot size: ",lot);
			break;
		}
		lot = MathRound(lot/MarketInfo(Symbol(),MODE_LOTSTEP))*MarketInfo(Symbol(),MODE_LOTSTEP);

		int ticket;
		color clr = Blue || Color1;
		if(MathMod(trade,2)>0) clr = Red ||Color1;
		if(trade>OP_SELL) {
		//	Alert(aorder[trade]," ",DoubleToStr(lot,2)," ",Symbol()," at ",DoubleToStr(price,Digits)," sl: ",DoubleToStr(sl,Digits)," tp: ",DoubleToStr(tp,Digits)," ...");
			ticket=OrderSend(Symbol(),trade,lot,price,Slippage,sl,tp,TradeComment,MagicNumber,0,clr);	
			if(ticket<1) Alert("Sending order failed!: "+ErrorDescription(GetLastError()));
			else {
				OrderSelect(ticket,SELECT_BY_TICKET);
		//	Alert("order was opened : #",ticket," ",aorder[trade]," ",DoubleToStr(lot,2)," ",Symbol(),
		//				" at ",DoubleToStr(OrderOpenPrice(),Digits)," sl: ",DoubleToStr(OrderStopLoss(),Digits)," tp: ",DoubleToStr(OrderTakeProfit(),Digits),".");
			}
			break;
		}	
		//Alert(aorder[trade]," ",DoubleToStr(lot,2)," ",Symbol()," at ",DoubleToStr(price,Digits)," sl: 0 tp: 0 ...");
		ticket=OrderSend(Symbol(),trade,lot,price,Slippage,0,0,TradeComment,MagicNumber,0,clr);
		if(ticket<1) {
			Alert("Sending order failed!: "+ErrorDescription(GetLastError()));	
			break;
		}
		//Alert("order was opened : #",ticket," ",aorder[trade]," ",DoubleToStr(lot,2)," ",Symbol(),
			//	" at ",DoubleToStr(OrderOpenPrice(),Digits)," sl: ",DoubleToStr(OrderStopLoss(),Digits)," tp: ",DoubleToStr(OrderTakeProfit(),Digits),".");
		OrderSelect(ticket,SELECT_BY_TICKET);
		//Alert("modify order #",OrderTicket()," ",aorder[trade]," ",DoubleToStr(lot,2)," ",Symbol()," at ",DoubleToStr(OrderOpenPrice(),Digits)," sl: 0 tp: 0 -> sl: ",DoubleToStr(sl,Digits)," tp: ",DoubleToStr(tp,Digits)," ...");
		bool res = OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,CLR_NONE);
		if(!res) Alert("Modifying order failed!: "+ErrorDescription(GetLastError()));		
		else {
			OrderSelect(ticket,SELECT_BY_TICKET);
	//		Alert("order #",OrderTicket()," ",aorder[trade]," ",DoubleToStr(lot,2)," ",Symbol()," at ",DoubleToStr(OrderOpenPrice(),Digits)," was modified -> sl: ",DoubleToStr(OrderStopLoss(),Digits)," tp: ",DoubleToStr(OrderTakeProfit(),Digits),".");
		}
		break;
	}
	//delete Order lines
	for(i=ObjectsTotal()-1; i>=0; i--) {
		obj = ObjectName(i);
		if(StringFind(obj,"EASYORDER_NEW",0)>=0) ObjectDelete(obj);
		ObjectsDeleteAll(OBJ_HLINE);
	}
	InitLines();
}
//+------------------------------------------------------------------+
void InitLines()
{
	string obj;
	int i, ticket;
	for(i=0; i<OrdersTotal(); i++) {
		OrderSelect(i,SELECT_BY_POS);
		if(OrderSymbol()==Symbol()) {
			ticket = OrderTicket();
			if(OrderType()>OP_SELL) {
				obj = "EASYORDER_MOD_PRICE_#"+ticket;
				if(ObjectFind(obj)>=0)	ObjectMove(obj,0,Time[0],OrderOpenPrice());
				else DrawLine("PRICE",ticket,OrderOpenPrice());				
			}
		}
	}
}
double RiskToLot(double risk, double price, double sl)
{  if(price==sl) return(0);
   double pv = MarketInfo(Symbol(),MODE_TICKVALUE) ;
   double pnt = MarketInfo(Symbol(),MODE_POINT);
   if(Digits == 3 || Digits == 5) {
   pnt *= 10;
   pv *= 10;
}
double delta = MathAbs(price-sl)/pnt;
double lot=AccountEquity()*risk/100 /delta/pv;
return(lot);
}
void DrawLine(string type, int ticket, double level)
{
	string obj = "EASYORDER_MOD_"+type+"_#"+ticket;
	color clr = Color1;
	if(type=="PRICE") clr = Color1;
	ObjectCreate(obj,OBJ_HLINE,0,Time[0],level,0,0);
	ObjectSet(obj,OBJPROP_COLOR,clr);
	ObjectSet(obj,OBJPROP_STYLE,Style1);
	ObjectSet(obj,OBJPROP_WIDTH,Width1);
}

